/* -*- c++ -*-
   god.h

   General Operations Director

   perform operations requiring omnipotence in the simulation
   $Id: god.h,v 1.8 1998/04/17 17:51:53 broch Exp $
   */

#ifndef __god_h
#define __god_h

#include <stdarg.h>

#include <object.h>
#include <packet.h>
#include <trace.h>

#include <cmu/node.h>

class God : public Connector {
public:
        God();

        int             command(int argc, const char* const* argv);

        void            recv(Packet *p, Handler *h);
        void            stampPacket(Packet *p);

        int initialized() {
                return num_nodes && min_hops && target_;
        }

        int             hops(int i, int j);
        static God*     instance() { assert(instance_); return instance_; }

private:
        int num_nodes;
        int* min_hops;   // square array of num_nodesXnum_nodes
                         // min_hops[i * num_nodes + j] giving 
			 // minhops between i and j
        static God*     instance_;
};

#endif
